import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class Flower {

    ArrayList<ArrayList<Integer>> cycles;
    ArrayList<String> stringCycles;
    int numV;

    Flower(){
        numV=36;
    }

    /*najde ktore vrcholy chybaju v kruzniciach danych suborom inF*/
    void doMisses() throws IOException {
        for(int i = 0; i < 3; i++) {
            numV = 20 + i * 8;
            cycles = new ArrayList<>();
            String inF = "./results/flower/sorted/nerozpustne/flower_" + numV + "_nerozpustne_n-4.txt";
            //String inF = "./results/flower/sorted/nerozpustne/flower_" + numV + "_nerozpustne_n-2.txt";
            Scanner scanner = new Scanner(new File(inF));
            while (scanner.hasNext()) {
                ArrayList<Integer> cycle = new ArrayList<>();
                for (int j = 0; j < numV - 4; j++) {
                    cycle.add(scanner.nextInt());
                }
                cycles.add(cycle);
            }
            //String outF = "./results/flower/not_in_cycles/nerozpustne/pairs/pairs_" + numV + "_not_in_cycles.txt";
            String outF = "./results/flower/not_in_cycles/nerozpustne/quadriples/quadriples_" + numV + "_not_in_cycles.txt";
            BufferedWriter writer = new BufferedWriter(new FileWriter(outF));
            for (ArrayList<Integer> cycle : cycles) {
                for (int j = 0; j < numV; j++) {
                    if (!cycle.contains(j)) writer.append(j + " ");
                }
                writer.append("\n");
            }
            writer.close();
        }
    }

    /*Zo suboru inF zoberie riadky a utriedene ich vypise na vystup*/
    void doStrings() throws IOException{
        for(int i = 0; i < 3; i++) {
            numV=20+i*8;
            stringCycles = new ArrayList<>();
            //String inF = "./results/flower/sorted/flower_" + numV + "_nerozpustne_n-4.txt";
            String inF = "./results/flower/not_in_cycles/nerozpustne/quadriples/quadriples_" + numV + "_not_in_cycles.txt";
            //String inF = "./results/flower/not_in_cycles/nerozpustne/pairs/pairs_" + numV + "_not_in_cycles.txt";
            Scanner scanner = new Scanner(new File(inF));
            while (scanner.hasNext()) {
                stringCycles.add(scanner.nextLine());
            }
            //String outF = "./results/flower/sorted/nerozpustne/flower_" + numV + "_nerozpustne_n-4.txt";
            String outF = "./results/flower/not_in_cycles/nerozpustne/quadriples/sorted/quadriples_" + numV + "_not_in_cycles_sorted.txt";
            //String outF = "./results/flower/not_in_cycles/nerozpustne/pairs/sorted/pairs_" + numV + "_not_in_cycles_sorted.txt";
            BufferedWriter writer = new BufferedWriter(new FileWriter(outF));
            Collections.sort(stringCycles);
            for (String cyc : stringCycles) {
                writer.append(cyc + "\n");
            }
            writer.close();
        }
    }
}
